VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Torfs Tetris"
   ClientHeight    =   2640
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   3510
   Icon            =   "TetrisMain.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   176
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   234
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Timer Timer2 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   3000
      Top             =   840
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   2520
      Top             =   840
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      ClipControls    =   0   'False
      Height          =   2400
      Left            =   120
      ScaleHeight     =   156
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   106
      TabIndex        =   0
      Top             =   120
      Width           =   1650
   End
   Begin VB.Label lblDemo 
      Alignment       =   2  'Zentriert
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1800
      TabIndex        =   5
      Top             =   2280
      Width           =   1575
   End
   Begin VB.Line Line1 
      X1              =   0
      X2              =   232
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Label lblLevel 
      Alignment       =   1  'Rechts
      BorderStyle     =   1  'Fest Einfach
      Caption         =   "1"
      Height          =   255
      Left            =   2520
      TabIndex        =   4
      Top             =   480
      Width           =   855
   End
   Begin VB.Label Label2 
      Caption         =   "Level"
      Height          =   255
      Left            =   2040
      TabIndex        =   3
      Top             =   480
      Width           =   495
   End
   Begin VB.Label lblScore 
      Alignment       =   1  'Rechts
      BorderStyle     =   1  'Fest Einfach
      Caption         =   "0"
      Height          =   255
      Left            =   2520
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Rows"
      Height          =   255
      Left            =   2040
      TabIndex        =   1
      Top             =   120
      Width           =   495
   End
   Begin VB.Menu mnuGame 
      Caption         =   "&Game"
      Begin VB.Menu mnuNew 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuBreak 
         Caption         =   "&Break"
         Shortcut        =   ^B
      End
      Begin VB.Menu mnuStop 
         Caption         =   "&Stop"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuSeperator1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuAbout 
         Caption         =   "&About"
         Shortcut        =   ^A
      End
      Begin VB.Menu mnuSeperator2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuQuit 
         Caption         =   "&Quit"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' _____________________________
'| Torfs Tetris                |
'| Written by Florian Brucker  |
'| SirTorf@web.de              |
'|_____________________________|
'
'Introduction:
'=============
'This is how this program works:
'The playing field is saved in an array (Field). The field is <Fwidth> units wide and
'<FHeight> units high. If a stone is on the field, his place is marked <True>. So if there
'is a stone at 5|10, Field(5,10).Stone returns <True>. The currebtly falling block is saved
'in an array (Block), too. Every block consists of 4 stones, which are saved with their specific
'position.
'When the timer bounces, the program checks if every stone in the block can be moved one unit
'down. If the check reutrns <True>, the block is moved. Otherwise a new block is added.
'When the user presses a key, the program checks if the block can move to the position the user
'wants him to move at. If this is <True>, the block is moved, else the block isn't moved ;-)
'The graphics are simple: Before the block is moved, we delete the block from the picturebox by
'painting him with backcolor. Then the coordiantes are changed and the we draw the block again,
'but this time with normal colors.
'
'For copyright and distribution infos, see the readme.txt
'
'Don't forget to vote if you like this.
'Keep up living - keep up coding


Option Explicit

Private Type XStone             'Every stone in the field
    X As Integer                'Position X
    Y As Integer                'Position Y
    Falls As Boolean            'Does this block fall ?
End Type



Const Unit = 5           'To calculate the graphics
Const FWidth = 15           'Width of the playing field
Const FHeight = 30          'Height of the playing field
Const RowsToGet = 5         'How many rows do you need before you get to the next level ?

Private Type FieldEntry     'For the field
    Stone As Boolean        'Is here a stone ?
    Checked As Boolean      'Have we checked this field already ?
    Color As Long           'Color of the stone
End Type

Private Field(1 To FWidth, 1 To FHeight) As FieldEntry   'Our playing field
Private IsFalling As Boolean                    'Does the whole block fall ?
Private ShowDemo As Boolean                     'Should we show the demo mode ?
Private DemoField(1 To FWidth, 1 To FHeight) As FieldEntry   'Field for the demo
Private Block(1 To 4) As XStone                     'The actually falling block
Private Score As Integer                        'How many rows have been completed yet
Private Level As Integer        'Which level has the user reached ?
Private Symbol As Integer       'Which symbol has the falling block , symbols are listed below
Private FirstBlock As Boolean   'Have we already added a falling block ?
Private GameRunning As Boolean  'Is the real game running ?
Private Break As Boolean        'Have a break ?

Private Colors(0 To 9, 1 To 2) As Long   'Constant colors of the stones

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long) 'Wait a bit

'Symbols:
'--------
'  #### : 1     ### : 2   ## : 3
'                #        ##
'
'  ## : 4  ## :5     # :6    #  :7
'   #      #        ##       ##
'   #      #        #         #


Private Function CanTurnBlock() As Boolean    'Can we turn the falling block ?
Dim TestBlock(1 To 4) As XStone
Dim TurnX As Integer
Dim TurnY As Integer
Dim SaveX As Integer
Dim Turn As Boolean
Dim c As Integer
    Select Case Symbol                      '-|
        Case 1, 2, 4, 6, 7                  ' |
            TurnX = Block(2).X              ' |
            TurnY = Block(2).Y              ' |
        Case 3                              ' |
            CanTurnBlock = True             ' |-> Select around which point we will turn the
            Exit Function                   ' |   block
        Case 5:                             ' |
            TurnX = Block(1).X              ' |
            TurnY = Block(1).Y              ' |
    End Select                              '-|
                        
    For c = 1 To 4
        TestBlock(c).X = Block(c).X - TurnX             '-|
        TestBlock(c).Y = Block(c).Y - TurnY             ' |
        SaveX = TestBlock(c).X                          ' |
        TestBlock(c).X = TestBlock(c).Y                 ' |-> Turning the block, just a bit of
        TestBlock(c).Y = -(SaveX)                       ' |   maths
        TestBlock(c).X = (TestBlock(c).X + TurnX)       ' |
        TestBlock(c).Y = (TestBlock(c).Y + TurnY)       ' |
    Next c                                              '-|
    
    Turn = True
    
    For c = 1 To 4                                         'Try if the block can be placed
        If TestBlock(c).X < 1 Or TestBlock(c).X > FWidth Or _
            TestBlock(c).Y < 1 Or TestBlock(c).Y > FHeight Then
            Turn = False
            Exit For
        End If
    Next c
    If Turn Then
        For c = 1 To 4
            If Field(TestBlock(c).X, TestBlock(c).X).Stone = True Then
                Turn = False
                Exit For
            End If
        Next c
    End If
    CanTurnBlock = Turn
End Function

Private Sub TurnBlock()        'Turn the block
Dim TurnX As Integer           'See CanTurnBlock for details
Dim TurnY As Integer
Dim c As Integer
Dim SaveX As Integer

    Select Case Symbol
        Case 1, 2, 4, 6, 7
            TurnX = Block(2).X
            TurnY = Block(2).Y
        Case 3
            Exit Sub
        Case 5:
            TurnX = Block(1).X
            TurnY = Block(1).Y
    End Select
    
    For c = 1 To 4
        Field(Block(c).X, Block(c).Y).Stone = False
    Next c
    
    For c = 1 To 4
        Block(c).X = Block(c).X - TurnX
        Block(c).Y = Block(c).Y - TurnY
        SaveX = Block(c).X
        Block(c).X = Block(c).Y
        Block(c).Y = -(SaveX)
        Block(c).X = (Block(c).X + TurnX)
        Block(c).Y = (Block(c).Y + TurnY)
    Next c
    
    For c = 1 To 4
        Field(Block(c).X, Block(c).Y).Stone = True
    Next c
End Sub

Private Function WholeBlockFalls() As Boolean 'Does the whole block fall ?
Dim Help As Boolean
Dim c As Integer
    Help = True
    For c = 1 To 4
        If Block(c).Falls = False Then Help = False         'If one stone of the block
    Next c                                                  'doesn't fall, the block doesn't
    WholeBlockFalls = Help                                  'fall
End Function

Private Function IsBlockThere(ByVal X As Integer, ByVal Y As Integer, ByVal Exclude As Integer)
Dim c As Integer                        'Check if there is a part of the block at these point
Dim Help As Boolean                     'Well don't check the part with index "Exclude"
    Help = False
    For c = 1 To 4
        If Block(c).X = X And Block(c).Y = Y And c <> Exclude Then Help = True
    Next c
    IsBlockThere = Help
End Function

Private Function CanMovePartThere(ByVal X As Integer, ByVal Y As Integer, ByVal c As Integer) As Boolean
    'Can we move the part of the block to this position ?
    CanMovePartThere = False
    If (X > 0 And X <= FWidth) And (Y > 0 And Y <= FHeight) Then
        If Field(X, Y).Stone = False And Not IsBlockThere(X, Y, c) Then CanMovePartThere = True
    End If
End Function

Private Function CanMoveBlock(ByVal NewX As Integer, ByVal NewY As Integer) As Boolean
Dim c As Integer            'Can we move the whole block to this position ?
Dim Help As Boolean
    
    Help = True
    
    For c = 1 To 4
        If Not (Block(c).X + NewX <= FWidth And Block(c).X + NewX > 0) Then
            Help = False
        ElseIf Not Block(c).Y + NewY <= FHeight Then
            Help = False
        Else
            If Field(Block(c).X + NewX, Block(c).Y + NewY).Stone And _
                IsBlockThere(Block(c).X + NewX, Block(c).Y + NewY, 0) = False Then Help = False
        End If
    Next c
    
    CanMoveBlock = Help And WholeBlockFalls
       
End Function


Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
Dim NewX As Integer
Dim NewY As Integer
Dim Changed As Boolean
Dim c As Integer
    If Not GameRunning Then Exit Sub
    Changed = False
    Select Case KeyCode
        Case vbKeyRight                         'Move the block right
                If CanMoveBlock(1, 0) Then
                    NewX = 1
                    Changed = True
                End If
        Case vbKeyLeft                          'Move left
                If CanMoveBlock(-1, 0) Then
                    NewX = -1
                    Changed = True
                End If
        Case vbKeyDown                          'Move down
                If CanMoveBlock(0, 1) Then
                    NewY = 1
                    Changed = True
                End If
        Case vbKeyUp                            'turn block
            If CanTurnBlock Then
                DrawBlock 0
                TurnBlock
                DrawBlock Symbol
            End If
    End Select
    
    If Changed Then
        MoveBlock NewX, NewY                    'Move block
    End If
    

End Sub

Private Sub Form_Load()
Dim a As Integer
Dim b As Integer
    Picture1.ScaleMode = 3
    Picture1.Height = (FHeight + 2) * Unit
    Picture1.Width = (FWidth + 2) * Unit
    For a = 1 To FWidth
        For b = 1 To FHeight
            Field(a, b).Stone = False
            Field(a, b).Checked = False
            Field(a, b).Color = Colors(0, 1)
        Next b
    Next a
    
    Colors(0, 1) = Picture1.BackColor       'Set the colors:
    Colors(0, 2) = Picture1.BackColor       'Colors(a,1):ForeGroundColor
    Colors(1, 1) = QBColor(7)               'Colors(a,2):Framecolor
    Colors(1, 2) = QBColor(8)               'Colors(0,)=Backcolor
    Colors(2, 1) = QBColor(12)
    Colors(2, 2) = QBColor(4)
    Colors(3, 1) = QBColor(13)
    Colors(3, 2) = QBColor(5)
    Colors(4, 1) = QBColor(9)
    Colors(4, 2) = QBColor(1)
    Colors(5, 1) = QBColor(10)
    Colors(5, 2) = QBColor(2)
    Colors(6, 1) = vbYellow
    Colors(7, 1) = vbCyan
    Colors(8, 1) = RGB(253, 183, 38)
    Colors(8, 2) = RGB(143, 97, 1)
    Colors(9, 1) = RGB(191, 193, 106)
    Colors(9, 2) = RGB(90, 91, 38)
    
    StopGame                                 'Stop game
    StartDemo True                          'Start the demo mode
End Sub

Private Sub StartGame()
Dim a As Integer
Dim b As Integer
    For a = 1 To FWidth                         'Empty all fields
        For b = 1 To FHeight
            Field(a, b).Stone = False
            Field(a, b).Checked = False
            Field(a, b).Color = Colors(0, 1)
        Next b
    Next a
    GameRunning = True                          'Now the game is running
    StartDemo False                             'Don't show the demo
    IsFalling = False                           'Block does not fall
    FirstBlock = True                           'FirstBlock is following
    Level = 1                                   'We're at level 1
    Score = -1                                  'Score =-1
    AddScore                                    'Now score=0
    Break = False                               'No break now
    mnuStop.Enabled = True                      'Enable menuitmes
    mnuBreak.Enabled = True
    Timer1.Enabled = True                       'Start the game !
End Sub

Private Sub StopGame()
    Timer1.Enabled = False                      'Stop game
    GameRunning = False                         'game isn't running anymore
    Break = False                               'No break now
    mnuStop.Enabled = False                     'disable menuitems
    mnuBreak.Enabled = False
End Sub

Private Sub BreakGame(ByVal BreakX As Boolean)      'Have a break ?
    If BreakX Then                                   'Yes:
        Timer1.Enabled = False                        'Stop game for a time
        lblDemo.Caption = "! Break !"                 'Show the break sign
        Break = True                                  'Now we have a break
        mnuBreak.Checked = True                         'check menuitem
    Else
        mnuBreak.Checked = False                    'No:
        Break = False                               'No break
        lblDemo.Caption = ""                        'No break sign
        Timer1.Enabled = True                       'Continue game
    End If
End Sub

Private Sub StartDemo(ByVal Start As Boolean)       'entertain the user ?
Dim a As Integer
Dim b As Integer
    Picture1.Cls                                    'Clear the picture
    For a = 1 To FWidth
        For b = 1 To FHeight
            DemoField(a, b).Stone = False               'Empty demo field
            DemoField(a, b).Checked = False
        Next b
    Next a
    If Start Then                                       'Yes:
        Timer2.Enabled = True                           'Start demo
        lblDemo.Caption = "! Demo-Mode !"               'Show sign
        ShowDemo = True                                 'Now we're in demomode
    Else                                                'No:
        ShowDemo = False                                'We aren't in demo mode
        Timer2.Enabled = False                          'Stop demo
        lblDemo.Caption = ""                            'No sign
    End If
End Sub

Private Sub AddBlock()  'Add new block after the last has stopped
Dim NewX As Integer
Dim F As Integer
Dim HBlock(1 To 4) As XStone
    Randomize

    If Not FirstBlock Then              'If we had a block before:
        For F = 1 To 4
            Field(Block(F).X, Block(F).Y).Stone = True      'Mark field
        Next F
        RemoveFullLines                                        'Check for completed lines
    Else
        FirstBlock = False
    End If
    
    DrawField                               'Let's draw a bit
    
    F = 0
    Do While F < 1
        F = Round(Rnd * 27 + 1) / 4          'Random block selection
    Loop
            
    Select Case F
        Case 1          'Now we add new coordinates
            NewX = Round(Rnd * (FWidth - 5) + 1)        'Symbol 1
            HBlock(1).X = NewX
            HBlock(1).Y = 1
            HBlock(2).X = NewX + 1
            HBlock(2).Y = 1
            HBlock(3).X = NewX + 2
            HBlock(3).Y = 1
            HBlock(4).X = NewX + 3
            HBlock(4).Y = 1
        Case 2                                  'Symbol 2
            NewX = Round(Rnd * (FWidth - 4) - 1)
            HBlock(1).X = NewX
            HBlock(1).Y = 1
            HBlock(2).X = NewX + 1
            HBlock(2).Y = 1
            HBlock(3).X = NewX + 2
            HBlock(3).Y = 1
            HBlock(4).X = NewX + 1
            HBlock(4).Y = 2
        Case 3                                  'Symbol 3
            NewX = Round(Rnd * (FWidth - 3) + 1)
            HBlock(1).X = NewX
            HBlock(1).Y = 1
            HBlock(2).X = NewX + 1
            HBlock(2).Y = 1
            HBlock(3).X = NewX
            HBlock(3).Y = 2
            HBlock(4).X = NewX + 1
            HBlock(4).Y = 2
        Case 4                                  'Symbol 4
            NewX = Round(Rnd * (FWidth - 3) + 1)
            HBlock(1).X = NewX
            HBlock(1).Y = 1
            HBlock(2).X = NewX + 1
            HBlock(2).Y = 1
            HBlock(3).X = NewX + 1
            HBlock(3).Y = 2
            HBlock(4).X = NewX + 1
            HBlock(4).Y = 3
        Case 5                                  'Symbol 5
            NewX = Round(Rnd * (FWidth - 3) + 1)
            HBlock(1).X = NewX
            HBlock(1).Y = 1
            HBlock(2).X = NewX + 1
            HBlock(2).Y = 1
            HBlock(3).X = NewX
            HBlock(3).Y = 2
            HBlock(4).X = NewX
            HBlock(4).Y = 3
        Case 6:                                 'Symbol 6
            NewX = Round(Rnd * (FWidth - 3) + 1)
            HBlock(1).X = NewX
            HBlock(1).Y = 2
            HBlock(2).X = NewX
            HBlock(2).Y = 3
            HBlock(3).X = NewX + 1
            HBlock(3).Y = 1
            HBlock(4).X = NewX + 1
            HBlock(4).Y = 2
        Case 7                                  'Symbol 7
            NewX = Round(Rnd * (FWidth - 3) + 1)
            HBlock(1).X = NewX
            HBlock(1).Y = 1
            HBlock(2).X = NewX
            HBlock(2).Y = 2
            HBlock(3).X = NewX + 1
            HBlock(3).Y = 2
            HBlock(4).X = NewX + 1
            HBlock(4).Y = 3
    End Select
    
    If CanAddBlock(HBlock) = False Then        'the user has lost if we can't add this block
        GameOver
        Exit Sub
    End If
    
    For NewX = 1 To 4                           'Add block
        Block(NewX) = HBlock(NewX)
    Next NewX
    
    Symbol = F
End Sub

Private Sub mnuAbout_Click()        'Show info box
Dim b As Boolean
    b = GameRunning
    If b Then                           'Have a break if we're playing
        BreakGame True
    Else
        StartDemo False                 'Stop demo if running
    End If
    frmInfo.Show vbModal
    If b Then
        BreakGame False                 'Continue game
    Else
        StartDemo True                      'Continue demo
    End If
End Sub

Private Sub mnuBreak_Click()
    BreakGame (Not Break)      'Change break state
End Sub

Private Sub mnuNew_Click()      'Start new game
    If GameRunning Then          'Really quit ?
        BreakGame True
        If MsgBox("Stop current game ?", vbYesNo + vbQuestion, "New Game") = vbNo Then
            BreakGame False
            Exit Sub
        End If
    End If
    BreakGame False             'No break
    StopGame                    'Stop current game
    StartGame                   'start new game
End Sub


Private Sub mnuStop_Click() 'Stop game !
    If GameRunning Then     'Are you sure ?
        BreakGame True
        If MsgBox("Stop current game ?", vbYesNo + vbQuestion, "Stop Game") = vbNo Then
            BreakGame False
            Exit Sub
        End If
    End If
    BreakGame False         'No break
    StopGame                 'stop the game
    StartDemo True          'show the demo
End Sub

Private Sub GameOver()      'Show game over message
Dim Msg As String
    Msg = "Game Over !" & vbCrLf & vbCrLf
    Msg = Msg & "You got " & Trim(Str(Score)) & " Points" & vbCrLf
    Msg = Msg & "and you went right up to level " & Trim(Str(Level)) & " !" & vbCrLf & vbCrLf
    Msg = Msg & "Would you like to play again ?"
    StopGame
    If MsgBox(Msg, vbYesNo + vbQuestion, "Game Over") = vbYes Then
        StartGame
    Else
        StartDemo True
    End If
End Sub

Private Sub Timer1_Timer()   'Make the block fall down
Dim c As Integer

    
    If Not IsFalling Then      'If we haven't got a falling block
        AddBlock                'Make a new block
        IsFalling = True        'Now he is falling
    End If

    For c = 1 To 4
        Block(c).Falls = False
    Next c
    

    
    For c = 1 To 4
        If Block(c).Y < FHeight Then
            If Not (Field(Block(c).X, Block(c).Y + 1).Stone And _
            IsBlockThere(Block(c).X, Block(c).Y + 1, c) = False) Then   'Check for every part
                Block(c).Falls = True
            End If
        End If
    Next c
    
    IsFalling = WholeBlockFalls       'If the whole block falls...
    
    If IsFalling Then
        MoveBlock 0, 1                  '...move the block
    End If
            
    If Not FirstBlock Then
        For c = 1 To 4
            Field(Block(c).X, Block(c).Y).Stone = True
        Next c
    End If
            
            
    DrawBlock Symbol     'Let's draw the block
    
    
End Sub

Private Sub MoveBlock(ByVal NewX As Integer, ByVal NewY As Integer) 'Move the block
Dim c As Integer
    For c = 1 To 4
            Field(Block(c).X, Block(c).Y).Stone = False
            Field(Block(c).X, Block(c).Y).Color = 0
    Next c
    DrawBlock 0             'Delete Block in picturebox
    For c = 1 To 4
            Block(c).Y = Block(c).Y + NewY
            Block(c).X = Block(c).X + NewX
            Field(Block(c).X, Block(c).Y).Stone = True
            Field(Block(c).X, Block(c).Y).Color = Symbol
    Next c
    DrawBlock Symbol        'Draw at new position
End Sub

Private Function CanAddBlock(TestBlock() As XStone) As Boolean 'Can we add the block ?
Dim c As Integer
Dim d As Integer
Dim CanAdd As Boolean
Dim Help As Boolean
    CanAdd = True
    For c = 1 To 4                      'If the block is inside the field...
        If TestBlock(c).X < 1 Or TestBlock(c).X > FWidth Or TestBlock(c).Y < 1 Or _
                    TestBlock(c).Y > FHeight Then
            CanAddBlock = False
            Exit Function
        End If
    Next c
    For c = 1 To 4              '...and the field is free
        If (Field(TestBlock(c).X, TestBlock(c).Y).Stone = True) Then
            CanAdd = False
        End If
    Next c
    CanAddBlock = CanAdd
End Function

Private Sub RemoveFullLines()      'Check for completed lines
Dim a As Integer
Dim b As Integer
Dim Full(1 To FHeight) As Boolean
Dim Check As Boolean

    b = FHeight
    Do While b > 0
        Check = True
        For a = 1 To FWidth
            If Field(a, b).Stone = False Then Check = False     'Check every row
        Next a
        If Check Then Exit Do
        b = b - 1
    Loop
    
    If b = 0 And Not Check Then Exit Sub        'No row completed ?
    If Not Check Then Exit Sub                  'Go home !
    
    'make the rows blink
    
    Picture1.Line (Unit - 2, b * Unit - 2)-(Unit * FWidth + 2, b * Unit + 2), Colors(6, 1), BF
    Picture1.Refresh
    Sleep 50
    Picture1.Line (Unit - 2, b * Unit - 2)-(Unit * FWidth + 2, b * Unit + 2), Colors(7, 1), BF
    Picture1.Refresh
    Sleep 50
    Picture1.Line (Unit - 2, b * Unit - 2)-(Unit * FWidth + 2, b * Unit + 2), Colors(6, 1), BF
    Picture1.Refresh
    Sleep 50
    
    'Move the whole field
    
    Do While b > 1
        For a = 1 To FWidth
            Field(a, b).Stone = Field(a, b - 1).Stone
            Field(a, b).Color = Field(a, b - 1).Color
        Next a
        b = b - 1
    Loop
    DrawField       'Draw the field
    
    AddScore        'Give him some points
    
    RemoveFullLines 'Check for further completed rows
    
    Exit Sub

End Sub

Private Sub AddScore()  'Add score and select speed & level
    Score = Score + 1
    lblScore.Caption = Score
    If Score Mod 10 <> 0 Then Exit Sub  'No new level
    Select Case Score / RowsToGet
        Case 0 To 6                     'Set speed of timer
            Timer1.Interval = 700 - (Score / 10)
        Case 7
            Timer1.Interval = 50
        Case 8
            Timer1.Interval = 20
        Case 9
            Timer1.Interval = 10
        Case Else
            Timer1.Interval = 1
    End Select
    
    Level = Score / RowsToGet + 1          'New level
    
    lblLevel.Caption = Level
End Sub

Private Sub DrawField()
Dim a As Integer
Dim b As Integer
    Picture1.Cls
    For a = 1 To FWidth
        For b = 1 To FHeight
            If Field(a, b).Stone Then DrawPart a, b, Field(a, b).Color  'Draw every stone
        Next b
    Next a
End Sub

Private Sub DrawPart(ByVal X As Integer, ByVal Y As Integer, ByVal ColorIndex As Byte)
    'Draw one stone and his frame
    Picture1.Line (X * Unit - 2, Y * Unit - 2)-(X * Unit + 2, Y * Unit + 2), Colors(ColorIndex, 1), BF
    Picture1.Line (X * Unit - 2, Y * Unit - 2)-(X * Unit - 2, Y * Unit + 2), Colors(ColorIndex, 2)
    Picture1.Line (X * Unit - 2, Y * Unit - 2)-(X * Unit + 2, Y * Unit - 2), Colors(ColorIndex, 2)
    Picture1.Line (X * Unit + 2, Y * Unit - 2)-(X * Unit + 2, Y * Unit + 2), Colors(ColorIndex, 2)
    Picture1.Line (X * Unit - 2, Y * Unit + 2)-(X * Unit + 3, Y * Unit + 2), Colors(ColorIndex, 2)
End Sub

Private Sub DrawBlock(ByVal ColorIndex As Byte)
Dim c As Integer

    For c = 1 To 4
       DrawPart Block(c).X, Block(c).Y, ColorIndex    'Draw the falling block
    Next c
    
End Sub

Private Sub DrawDemo()       'Draw the demo
Dim a As Integer             'See Timer1_Timer for details
Dim b As Integer
Dim Full As Boolean
    
    Randomize

    For a = 1 To FWidth
        For b = 1 To FHeight
            DemoField(a, b).Checked = False
        Next b
    Next a

    Full = True
    For a = 1 To FWidth
        For b = 1 To 29
            If DemoField(a, b).Stone And Not DemoField(a, b).Checked Then
                If Not DemoField(a, b + 1).Stone Then
                    DemoField(a, b).Stone = False
                    DemoField(a, b + 1).Checked = True
                    DemoField(a, b + 1).Stone = True
                    Picture1.Line (a * Unit - 2, b * Unit - 2)-(a * Unit + 2, b * Unit + 2), Colors(0, 1), BF
                    Picture1.Line (a * Unit - 2, (b + 1) * Unit - 2)-(a * Unit + 2, (b + 1) * Unit + 2), RGB(Rnd * 255, Rnd * 255, Rnd * 255), BF
                End If
            Else
                Full = False
            End If
        Next b
    Next a
    
    If Full Then
        For a = 1 To FWidth
            For b = 1 To FHeight
                DemoField(a, b).Stone = False
            Next b
        Next a
    End If
    
    DemoField(Rnd * (FWidth - 1) + 1, 1).Stone = True
    DemoField(Rnd * (FWidth - 1) + 1, 1).Stone = True
End Sub

Private Sub Timer2_Timer()    'Make the demo move
    DrawDemo
End Sub
